package com.jiuqi.util;

package .tmp;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

public class DateUtil {
  private static SimpleDateFormat formatter1;
  
  private static SimpleDateFormat formatter2;
  
  private static SimpleDateFormat formatter3;
  
  private static SimpleDateFormat formatter4;
  
  private static SimpleDateFormat formatter5;
  
  private static SimpleDateFormat[] formatters;
  
  private static int[][] _LunarCal = new int[][] { 
      { 
        23, 3, 2, 17, 1, 1, 1, 1, 1, 1, 
        1 }, { 41, 4, 23, 1, 1, 1, 1, 1, 1, 1 }, { 
        30, 7, 5, 28, 1, 1, 1, 1, 1, 1, 
        1 }, { 49, 6, 33, 1, 1, 1, 1, 1, 1, 1 }, { 38, 38, 1, 1, 1, 1, 1, 1, 1 }, { 
        26, 6, 2, 44, 1, 1, 1, 1, 1, 1, 
        1 }, { 45, 3, 49, 1, 1, 1, 1, 1, 1, 1 }, { 35, 4, 54, 1, 1, 1, 1, 1, 1, 1 }, { 
        24, 4, 5, 59, 1, 1, 1, 1, 1, 1, 
        1, 1 }, { 43, 5, 1, 1, 1, 1, 1, 1, 1 }, 
      { 32, 1, 10, 1, 1, 1, 1, 1, 1, 1 }, { 
        21, 2, 2, 15, 1, 1, 1, 1, 1, 1, 
        1 }, { 40, 3, 20, 1, 1, 1, 1, 1, 1, 1 }, { 
        28, 7, 5, 26, 1, 1, 1, 1, 1, 1, 
        1 }, { 47, 6, 31, 1, 1, 1, 1, 1, 1, 1 }, { 36, 36, 1, 1, 1, 1, 1, 1, 1 }, { 
        26, 5, 1, 41, 1, 1, 1, 1, 1, 1, 
        1 }, { 44, 3, 47, 1, 1, 1, 1, 1, 1, 1 }, { 33, 4, 52, 1, 1, 1, 1, 1, 1, 1 }, { 
        23, 3, 5, 57, 1, 1, 1, 1, 1, 1, 
        1 }, 
      { 42, 6, 2, 1, 1, 1, 1, 1, 1, 1 }, { 30, 8, 1, 8, 1, 1, 1, 1, 1, 1 }, { 48, 2, 13, 1, 1, 1, 1, 1, 1, 1 }, { 38, 3, 18, 1, 1, 1, 1, 1, 1, 1 }, { 
        27, 6, 4, 23, 1, 1, 1, 1, 1, 1, 
        1 }, { 45, 6, 29, 1, 1, 1, 1, 1, 1, 1 }, { 35, 34, 1, 1, 1, 1, 1, 1, 1 }, { 
        24, 4, 1, 39, 1, 1, 1, 1, 1, 1, 
        1 }, { 43, 2, 44, 1, 1, 1, 1, 1, 1, 1 }, { 32, 4, 50, 1, 1, 1, 1, 1, 1 }, 
      { 
        20, 3, 5, 55, 1, 1, 1, 1, 1, 1, 
        1 }, { 39, 6, 1, 1, 1, 1, 1, 1, 1 }, { 29, 7, 5, 1, 1, 1, 1, 1, 1, 1 }, { 47, 2, 11, 1, 1, 1, 1, 1, 1, 1 }, { 36, 3, 16, 1, 1, 1, 1, 1, 1, 1 }, { 
        26, 5, 4, 21, 1, 1, 1, 1, 1, 1, 
        1 }, { 45, 5, 26, 1, 1, 1, 1, 1, 1, 1 }, { 33, 32, 1, 1, 1, 1, 1, 1, 1 }, { 
        22, 4, 1, 37, 1, 1, 1, 1, 1, 1, 
        1 }, { 41, 2, 42, 1, 1, 1, 1, 1, 1, 1 }, 
      { 
        30, 8, 3, 47, 1, 1, 1, 1, 1, 1, 
        1 }, { 48, 5, 53, 1, 1, 1, 1, 1, 1, 1 }, { 
        37, 6, 58, 1, 1, 1, 1, 1, 1, 1, 
        1 }, { 27, 6, 3, 1, 1, 1, 1, 1, 1, 1 }, { 46, 1, 8, 1, 1, 1, 1, 1, 1, 1 }, { 35, 3, 14, 1, 1, 1, 1, 1, 1, 1 }, { 
        24, 4, 4, 19, 1, 1, 1, 1, 1, 1, 
        1 }, { 43, 5, 24, 1, 1, 1, 1, 1, 1, 1 }, { 
        32, 10, 6, 29, 1, 1, 1, 1, 1, 1, 
        1 }, { 50, 1, 35, 1, 1, 1, 1, 1, 1 }, 
      { 39, 2, 40, 1, 1, 1, 1, 1, 1, 1 }, { 
        28, 6, 3, 45, 1, 1, 1, 1, 1, 1, 
        1 }, { 
        47, 4, 50, 1, 1, 1, 1, 1, 1, 1, 
        1 }, { 36, 6, 56, 1, 1, 1, 1, 1, 1, 1 }, { 26, 5, 1, 1, 1, 1, 1, 1, 1, 1 }, { 45, 1, 6, 1, 1, 1, 1, 1, 1 }, { 34, 2, 11, 1, 1, 1, 1, 1, 1 }, { 22, 3, 4, 17, 1, 1, 1, 1, 1, 1 }, { 40, 5, 22, 1, 1, 1, 1, 1, 1, 1 }, { 
        30, 8, 6, 27, 1, 1, 1, 1, 1, 1, 
        1 }, 
      { 49, 32, 1, 1, 1, 1, 1, 1, 1 }, { 
        37, 2, 38, 1, 1, 1, 1, 1, 1, 1, 
        1 }, { 
        27, 5, 3, 43, 1, 1, 1, 1, 1, 1, 
        1 }, { 46, 4, 48, 1, 1, 1, 1, 1, 1, 1 }, { 35, 5, 53, 1, 1, 1, 1, 1, 1, 1 }, { 23, 4, 59, 1, 1, 1, 1, 1, 1, 1 }, { 42, 1, 4, 1, 1, 1, 1, 1, 1, 1 }, { 31, 2, 9, 1, 1, 1, 1, 1, 1, 1 }, { 
        21, 2, 3, 14, 1, 1, 1, 1, 1, 1, 
        1 }, { 39, 5, 20, 1, 1, 1, 1, 1, 1, 1 }, 
      { 
        28, 7, 6, 25, 1, 1, 1, 1, 1, 1, 
        1, 1 }, { 48, 30, 1, 1, 1, 1, 1, 1, 1 }, { 37, 1, 35, 1, 1, 1, 1, 1, 1, 1 }, { 
        25, 5, 3, 41, 1, 1, 1, 1, 1, 1, 
        1 }, { 44, 4, 46, 1, 1, 1, 1, 1, 1, 1 }, { 33, 5, 51, 1, 1, 1, 1, 1, 1, 1 }, { 
        22, 4, 6, 56, 1, 1, 1, 1, 1, 1, 
        1 }, { 40, 1, 2, 1, 1, 1, 1, 1, 1, 1 }, { 
        30, 9, 2, 7, 1, 1, 1, 1, 1, 1, 
        1 }, { 49, 3, 12, 1, 1, 1, 1, 1, 1, 1 }, 
      { 38, 4, 17, 1, 1, 1, 1, 1, 1, 1 }, { 
        27, 6, 6, 23, 1, 1, 1, 1, 1, 1, 
        1 }, { 46, 28, 1, 1, 1, 1, 1, 1 }, { 35, 1, 33, 1, 1, 1, 1, 1, 1 }, { 
        24, 4, 2, 38, 1, 1, 1, 1, 1, 1, 
        1 }, { 42, 4, 44, 1, 1, 1, 1, 1, 1, 1 }, { 31, 5, 49, 1, 1, 1, 1, 1, 1, 1 }, { 
        21, 2, 6, 54, 1, 1, 1, 1, 1, 1, 
        1 }, { 40, 59, 1, 1, 1, 1, 1, 1, 1 }, { 
        28, 6, 2, 5, 1, 1, 1, 1, 1, 1, 
        1 }, 
      { 47, 3, 10, 1, 1, 1, 1, 1, 1, 1 }, { 36, 4, 15, 1, 1, 1, 1, 1, 1, 1 }, { 
        25, 5, 5, 20, 1, 1, 1, 1, 1, 1, 
        1 }, { 43, 26, 1, 1, 1, 1, 1, 1, 1 }, { 32, 1, 31, 1, 1, 1, 1, 1, 1, 1 }, { 
        22, 3, 2, 36, 1, 1, 1, 1, 1, 1, 
        1 } };
  
  private static int[][] _SolarDays = new int[][] { { 
        0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 
        304, 334, 365, 396 }, { 
        0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 
        305, 335, 366, 397 } };
  
  private static int FIRSTYEAR = 1936;
  
  private static int[][] BC = new int[][] { { 
        1979, 1982, 1984, 1987, 1990, 1993, 1995, 1998, 2001, 2004, 
        2006, 2009, 2012, 2014, 2017, 2020, 2023, 2025, 2028 }, { 
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
        1, 1, 1, 1, 1, 1, 1, 1, 1 } };
  
  private static int[][] _MonthDays = new int[][] { { 
        31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 
        30, 31 }, { 
        31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 
        30, 31 } };
  
  private static int GetLeap(int Year) {
    if (Year % 400 == 0)
      return 1; 
    if (Year % 100 == 0)
      return 0; 
    if (Year % 4 == 0)
      return 1; 
    return 0;
  }
  
  public static ArrayList getWeekEnd(long startday, long endday) {
    ArrayList<String> week = new ArrayList();
    GregorianCalendar day1 = new GregorianCalendar(Integer.parseInt(String.valueOf(startday).substring(0, 4)), Integer.parseInt(String.valueOf(startday).substring(4, 6)) - 1, 
        Integer.parseInt(String.valueOf(startday).substring(6, 8)));
    int rcount = 0;
    while (true) {
      long day = Long.parseLong(convertDateToString(day1.getTime()));
      if (day <= endday) {
        int year = Integer.parseInt(String.valueOf(day).substring(0, 4));
        int month = Integer.parseInt(String.valueOf(day).substring(4, 6));
        int dday = Integer.parseInt(String.valueOf(day).substring(6, 8));
        if (getWeekByDay(year, month, dday) == 0 || getWeekByDay(year, month, dday) == 6) {
          String sweek = "周六";
          if (getWeekByDay(year, month, dday) == 0)
            sweek = "周日"; 
          week.add(String.valueOf(year) + "年" + month + "月" + dday + "日(" + sweek + ")");
        } 
        day1.add(5, 1);
        rcount++;
        if (rcount > 1095)
          break; 
        continue;
      } 
      break;
    } 
    return week;
  }
  
  public static int getWeekByDay(int year, int month, int day) {
    int w = 0;
    int[] DaysInMonth = { 
        31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 
        30, 31 };
    if (IsLeapYear(year))
      DaysInMonth[1] = 29; 
    int firstdayw = CalcJanuaryFirst(year);
    int sumday = 0;
    for (int i = 0; i < month - 1; i++)
      sumday += DaysInMonth[i]; 
    sumday = sumday + day - 1;
    int deferday = sumday % 7;
    w = (deferday + firstdayw) % 7;
    return w;
  }
  
  public static String getMonthByWeek(String year, String weekperiod, String weekday) {
    String returnValue = "";
    int month = 1;
    int day = 1;
    int[] DaysInMonth = { 
        31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 
        30, 31 };
    if (IsLeapYear(Integer.parseInt(year)))
      DaysInMonth[1] = 29; 
    int firstweekday = CalcJanuaryFirst(Integer.parseInt(year));
    int days = (Integer.parseInt(weekperiod) - 1) * 7 + Integer.parseInt(weekday);
    if (firstweekday != 1)
      days = (Integer.parseInt(weekperiod) - 1) * 7 + Integer.parseInt(weekday) + 7 - firstweekday + 1; 
    int tmpw = firstweekday - 1;
    int plusday = 0;
    boolean getflag = false;
    for (int i = 0; i < 12; i++) {
      if (!getflag)
        for (int k = 1; k <= DaysInMonth[i]; k++) {
          if (tmpw == 7)
            tmpw = 0; 
          plusday++;
          tmpw++;
          if (plusday == days) {
            month = i + 1;
            day = k;
            getflag = true;
            break;
          } 
        }  
    } 
    String sMonth = String.valueOf(month);
    if (month < 10)
      sMonth = "0" + month; 
    String sDay = String.valueOf(day);
    if (day < 10)
      sDay = "0" + day; 
    returnValue = String.valueOf(sMonth) + sDay;
    return returnValue;
  }
  
  public static int CalcJanuaryFirst(int year) {
    if (year < 1582)
      return -1; 
    return (5 + year - 1582 + CalcLeapYears(year)) % 7;
  }
  
  private static int CalcLeapYears(int year) {
    if (year < 1582)
      return -1; 
    int leapYears = (year - 1581) / 4;
    int hundreds = (year - 1501) / 100;
    leapYears -= hundreds;
    int fourHundreds = (year - 1201) / 400;
    leapYears += fourHundreds;
    return leapYears;
  }
  
  public static boolean IsLeapYear(int year) {
    if (year % 100 == 0)
      return (year % 400 == 0); 
    return (year % 4 == 0);
  }
  
  public static String getDateFromLunar(int year, int month, int day) {
    int y = 0, m = 0, d = 0;
    int nDiffYear = year - FIRSTYEAR;
    int nTotalDay = _LunarCal[nDiffYear][0];
    int i;
    for (i = 0; i < (BC[0]).length; i++) {
      if (year == BC[0][i]) {
        month += BC[1][i];
        break;
      } 
    } 
    for (i = 0; i < month - 1; i++)
      nTotalDay += _LunarCal[nDiffYear][4 + i] + 29; 
    nTotalDay += day;
    int nSolarLeap = GetLeap(year);
    for (int j = 13; j >= 0; j--) {
      if (nTotalDay > _SolarDays[nSolarLeap][j]) {
        d = nTotalDay - _SolarDays[nSolarLeap][j];
        if (j <= 11) {
          y = year;
          m = j + 1;
          break;
        } 
        y = year + 1;
        m = j - 11;
        break;
      } 
    } 
    String returnValue = String.valueOf(y) + ((m < 10) ? ("0" + m) : String.valueOf(m)) + ((d < 10) ? ("0" + d) : String.valueOf(d));
    return returnValue;
  }
  
  public static int calcDates(long sdate, long edate) {
    Date enddate = convertStringToDate(String.valueOf(sdate));
    Date startdate = convertStringToDate(String.valueOf(edate));
    return Math.round((float)((enddate.getTime() - startdate.getTime()) / 1000L / 60L / 60L / 24L));
  }
  
  static {
    try {
      formatter1 = new SimpleDateFormat("yyyyMMdd");
      formatter2 = new SimpleDateFormat("yyyy'-'MM'-'dd");
      formatter3 = new SimpleDateFormat("yyyyMMddHHmmss");
      formatter4 = new SimpleDateFormat("yyyy'-'MM'-'dd HH':'mm':'ss");
      formatter5 = new SimpleDateFormat("yyyy'年'MM'月'dd'日' E");
      formatters = new SimpleDateFormat[] { formatter2, formatter1, formatter3, formatter4, formatter5 };
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  public static String convertDateString(String dateString) {
    return formatter2.format(convertStringToDate(dateString));
  }
  
  public static Date convertStringToDate(String dateString) {
    try {
      return formatter1.parse(dateString);
    } catch (Exception exception) {
      return new Date();
    } 
  }
  
  public static String convertDateToString(Date date) {
    return formatter1.format(date);
  }
  
  public static String convertDateToString1(Date date) {
    return formatter2.format(date);
  }
  
  public static String convertTimeString(String timeString) {
    return formatter4.format(convertStringToTime(timeString));
  }
  
  public static String convertTimeString1(String timeString) {
    return formatter1.format(convertStringToDate1(timeString));
  }
  
  public static Date convertStringToDate1(String timeString) {
    try {
      return formatter2.parse(timeString);
    } catch (Exception exception) {
      return new Date();
    } 
  }
  
  public static Date convertStringToTime(String timeString) {
    try {
      return formatter3.parse(timeString);
    } catch (Exception exception) {
      return new Date();
    } 
  }
  
  public static String convertTimeToString(Date time) {
    return formatter3.format(time);
  }
  
  public static String getDateWeekString(Date time) {
    return formatter5.format(time);
  }
  
  public static String getLunarDescrible(int month, int day) {
    String s, returnValue = "";
    String[] lunmonth = { 
        "正", "正", "二", "三", "四", "五", "六", "七", "八", "九", 
        "十", "十一", "十二" };
    String[] nStr1 = { 
        "日", "一", "二", "三", "四", "五", "六", "七", "八", "九", 
        "十" };
    String[] nStr2 = { "初", "十", "廿", "卅", "　" };
    switch (day) {
      case 10:
        s = "初十";
        break;
      case 20:
        s = "二十";
        break;
      case 30:
        s = "三十";
        break;
      default:
        s = nStr2[day / 10];
        s = String.valueOf(s) + nStr1[day % 10];
        break;
    } 
    try {
      returnValue = String.valueOf(lunmonth[month]) + "月" + s;
    } catch (Exception exception) {
      System.out.println("农历月日表述转换错误!");
      returnValue = String.valueOf(month) + day;
    } 
    return returnValue;
  }
  
  public static String getStrDateFromTime(long mitime) {
    Calendar date = Calendar.getInstance();
    date.setTimeInMillis(mitime);
    String strDate = "";
    int month = date.get(2) + 1;
    int strYear = date.get(1);
    strDate = String.valueOf(Integer.toString(strYear)) + "-";
    if (month >= 10) {
      strDate = String.valueOf(strDate) + Integer.toString(month) + "-";
    } else {
      strDate = String.valueOf(strDate) + "0" + Integer.toString(month) + "-";
    } 
    if (date.get(5) >= 10) {
      strDate = String.valueOf(strDate) + Integer.toString(date.get(5)) + " ";
    } else {
      strDate = String.valueOf(strDate) + "0" + Integer.toString(date.get(5)) + " ";
    } 
    if (date.get(11) >= 10) {
      strDate = String.valueOf(strDate) + Integer.toString(date.get(11)) + ":";
    } else {
      strDate = String.valueOf(strDate) + "0" + Integer.toString(date.get(11)) + ":";
    } 
    if (date.get(12) >= 10) {
      strDate = String.valueOf(strDate) + Integer.toString(date.get(12)) + ":";
    } else {
      strDate = String.valueOf(strDate) + "0" + Integer.toString(date.get(12)) + ":";
    } 
    if (date.get(13) >= 10) {
      strDate = String.valueOf(strDate) + Integer.toString(date.get(13));
    } else {
      strDate = String.valueOf(strDate) + "0" + Integer.toString(date.get(13));
    } 
    return strDate;
  }
  
  public static String getStrDateFromMitime(long mitime) {
    Calendar date = Calendar.getInstance();
    date.setTimeInMillis(mitime);
    String strDate = "";
    int strMonth = date.get(2) + 1;
    int strYear = date.get(1);
    strDate = Integer.toString(strYear);
    if (strMonth >= 10) {
      strDate = String.valueOf(strDate) + Integer.toString(strMonth);
    } else {
      strDate = String.valueOf(strDate) + "0" + Integer.toString(strMonth);
    } 
    if (date.get(5) >= 10) {
      strDate = String.valueOf(strDate) + Integer.toString(date.get(5));
    } else {
      strDate = String.valueOf(strDate) + "0" + Integer.toString(date.get(5));
    } 
    if (date.get(11) >= 10) {
      strDate = String.valueOf(strDate) + Integer.toString(date.get(11));
    } else {
      strDate = String.valueOf(strDate) + "0" + Integer.toString(date.get(11));
    } 
    if (date.get(12) >= 10) {
      strDate = String.valueOf(strDate) + Integer.toString(date.get(12));
    } else {
      strDate = String.valueOf(strDate) + "0" + Integer.toString(date.get(12));
    } 
    return strDate;
  }
  
  public static String date2String(Date date) {
    return formatter2.format(date);
  }
  
  public static String date2String(long time) {
    return date2String(new Date(time));
  }
  
  public static String dateTime2String(Date dateTime) {
    return formatter4.format(dateTime);
  }
  
  public static String dateTime2String(long dateTime) {
    return dateTime2String(new Date(dateTime));
  }
  
  public static int getDaysInAMonth(int year, int month) {
    return _MonthDays[IsLeapYear(year) ? 1 : 0][month];
  }
  
  public static Date tryParserDateString(String dateString) {
    if (dateString == null || dateString.length() == 0)
      return null; 
    for (int i = 0; i < formatters.length; i++) {
      try {
        return formatters[i].parse(dateString);
      } catch (ParseException parseException) {}
    } 
    return null;
  }
}
